# Cyber Pay Flutter Plugin

A Flutter package allows you to easily implement the Cyber Pay Credit Card's UI easily with the Card detection.

[![Codacy Badge](https://api.codacy.com/project/badge/Grade/e546818ff64e4883a18a920f6a1c091c)](https://github.com/cyberspace-ltd/cyberpay-flutter.git)

## Installing

1.  Add dependency to `pubspec.yaml`

    *Get the latest version in the 'Installing' tab on pub.dartlang.org*
    
```dart
dependencies:
    cyberpaysdkflutter: ^1.0.0+22
```

2.  Import the package
```dart
import 'dart:async';
import 'package:flutter/services.dart';
import 'package:cyberpayflutter_plugin/cyberpayflutter_plugin.dart';


```

3.1  Adding TransactionObject

*With required parameters*
```dart

    await CyberpayflutterPlugin.makePayment(integrationKey: "INTEGRATION_KEY", customerEmail: "shaba@gmail.com", amount: AMOUNT IN KOBO, liveMode: true );
     
```    
3.2  Call Cyberpay SDK in a Payment Button

```dart

 FlatButton(
         onPressed: () async {
           try {
             await CyberpayflutterPlugin.makePayment(integrationKey: "INTEGRATION_KEY", customerEmail: "shaba@gmail.com", amount: 200000, liveMode: true );

           } on PlatformException catch (e) {
             response = "Failed to Invoke: '${e.message}'.";
           }
         },

```
4.  Get Response Back from InitState

```dart

 @override
   void initState() {
     super.initState(); 
     
     platform.setMethodCallHandler((call) {
       final String argument = call.arguments;
       switch (call.method) {
         case "onSuccess":
           
          print("SUCCESS $argument");
 
           break;
       }
       return;

     });
   }

```

## How to use
Check out the **example** app in the [example](example) directory or the 'Example' tab on pub.dartlang.org for a more complete example.

## Getting Started

This project is a starting point for a Dart
[package](https://flutter.dev/developing-packages/),
a library module containing code that can be shared easily across
multiple Flutter or Dart projects.

For help getting started with Flutter, view our 
[online documentation](https://flutter.dev/docs), which offers tutorials, 
samples, guidance on mobile development, and a full API reference.
