package ng.net.cyberpay.cyberpayflutter_plugin;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.widget.Toast;

import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;

import io.flutter.BuildConfig;
import io.flutter.app.FlutterActivity;
import io.flutter.plugin.common.EventChannel;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry;
import io.flutter.plugin.common.PluginRegistry.Registrar;

import com.cyberspace.cyberpaysdk.CyberpaySdk;
import com.cyberspace.cyberpaysdk.TransactionCallback;
import com.cyberspace.cyberpaysdk.enums.Mode;
import com.cyberspace.cyberpaysdk.model.Booking;
import com.cyberspace.cyberpaysdk.model.Transaction;


/**
 * CyberpayflutterPlugin
 */
public class CyberpayflutterPlugin implements MethodCallHandler, PluginRegistry.ActivityResultListener {

    Booking booking;

    private final MethodChannel channel;
    private Activity activity;
    private Context context;
    int RESULT_CODE = 1;

    private CyberpayflutterPlugin(Context context, Activity activity, MethodChannel channel) {
        this.activity = activity;
        this.context = context;
        this.channel = channel;
        this.channel.setMethodCallHandler(this);
        booking = new Booking();


    }


    /**
     * Plugin registration.
     */
    public static void registerWith(Registrar registrar) {
        final MethodChannel channel = new MethodChannel(registrar.messenger(), "cyberpayflutter_plugin");
        CyberpayflutterPlugin instance = new CyberpayflutterPlugin(registrar.context(), registrar.activity(), channel);
        registrar.addActivityResultListener(instance);
        channel.setMethodCallHandler(instance);
    }

    @Override
    public void onMethodCall(MethodCall call, Result result) {
        if (call.method.equals("checkout")) {
            String integrationKey = call.argument("integrationKey").toString();
            double amount = (Double) call.argument("amount");
            String customerEmail = call.argument("customerEmail").toString();
            boolean liveMode = (Boolean) call.argument("liveMode");

//            Toast.makeText(activity, integrationKey, Toast.LENGTH_SHORT).show();

            booking.setAmount(amount);
            booking.setCustomerEmail(customerEmail);

            Intent intent = new Intent(
                    activity, PaymentActivity.class);
            intent.putExtra("bookingTransaction", booking);
            intent.putExtra("integrationKey", integrationKey);
            intent.putExtra("mode", liveMode);

            activity.startActivityForResult(intent, RESULT_CODE);
            result.success(null);
        } else {
            result.notImplemented();
        }
    }

    @Override
    public boolean onActivityResult(int requestCode, int resultCode, Intent data) {
        if (requestCode == RESULT_CODE) {
            if (resultCode == Activity.RESULT_OK) {
                String result = data.getStringExtra("result");
                channel.invokeMethod("onSuccess", result);
                return true;
            }
        }
        return false;
    }

}

