import 'dart:async';

import 'package:flutter/material.dart';
import 'package:flutter/services.dart';

enum Mode { LIVE, DEBUG }

class CyberpayflutterPlugin {
  static const MethodChannel _channel =
      const MethodChannel('cyberpayflutter_plugin');

  static Future<String> get platformVersion async {
    final String version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static Future<Null> makePayment(
      {@required String integrationKey,
      @required double amount,
      @required String customerEmail,
      @required bool liveMode}) async {
    final Map<String, dynamic> params = <String, dynamic>{
      "integrationKey": integrationKey,
      "amount": amount,
      "customerEmail": customerEmail,
      "liveMode": liveMode
    };
//    params.putIfAbsent("msg", ()=> message);
    await _channel.invokeMethod('checkout', params);
    return null;
  }
}
